using System;
using System.Collections;
using System.Collections.Generic;
using Cysharp.Threading.Tasks;

namespace Project.B.Player
{
    public interface IPlayerService
    {
        /// <summary>
        /// 获取玩家信息 
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        UniTask<IPlayerData> GetPlayerDataAsync(Guid id);
        /// <summary>
        /// 获取玩家信息
        /// </summary>
        /// <param name="ids"></param>
        /// <returns></returns>
        UniTask<IReadOnlyCollection<IPlayerData>> GetPlayersDataAsync(IReadOnlyCollection<Guid> ids);
        /// <summary>
        /// 创建或更新玩家信息
        /// </summary>
        /// <param name="playerData"></param>
        /// <returns></returns>
        UniTask<IPlayerData> CreateOrUpdatePlayerAsync(IPlayerData playerData);
    }
}

