using System;
using System.Collections;
using System.Collections.Generic;
using Cysharp.Threading.Tasks;

namespace Project.B.Skin
{
    /// <summary>
    /// 玩家皮肤服务
    /// </summary>
    public interface IPlayerSkinService 
    {
        /// <summary>
        /// 获取玩家已装备皮肤数据
        /// </summary>
        /// <param name="playerId"></param>
        /// <returns></returns>
        public UniTask<IPlayerReplacedSkinData> GetPlayerReplacedSkinDataAsync(Guid playerId);
        /// <summary>
        /// 获取玩家已装备皮肤数据
        /// </summary>
        /// <param name="playerIds"></param>
        /// <returns></returns>
        public UniTask<IPlayerReplacedSkinData[]> GetPlayersReplacedSkinDataAsync(params Guid[] playerIds);
        /// <summary>
        /// 获取玩家皮肤数据
        /// </summary>
        /// <param name="playerId"></param>
        /// <returns></returns>
        public UniTask<IPlayerSkinData[]> GetPlayerSkinDataAsync(Guid playerId);
    }
}
